# 科学家可以读取一只鸟的大脑并且预测它的下一声啼叫

原文链接：[Scientists Can Read a Bird’s Brain and Predict Its Next Song](https://www.technologyreview.com/s/609032/scientists-can-read-a-birds-brain-and-predict-its-next-song/?from=hackcv&hmsr=hackcv.com&utm_medium=hackcv.com&utm_source=hackcv.com)

## 下一步，通过一个脑机接口预测人类的讲话。

​	在硅谷的企业家们今年给自己设定了一个大胆的新目标：创造一个读脑设备使人们可以通过他们的思想毫不费力的传递信息。

​	在四月，埃隆 · 马斯克爆出了一家叫做“[Neuralink](https://www.technologyreview.com/s/604254/with-neuralink-elon-musk-promises-human-to-human-telepathy-dont-believe-it/) ”的人脑接口新公司。几天后，脸书的CEO马克 · 扎克伯格宣称：“可用的人脑接口即将到来，最终，让你可以只用你的思想进行交流。”脸书表示有[六十名工程师](https://www.technologyreview.com/s/604229/facebooks-sci-fi-plan-for-typing-with-your-mind-and-hearing-with-your-skin/)正在研究这个问题。

​	这是一个有野心的探索，并且我们有理由认为它不会很快的就发生。但至少对一只橙色喙的小鸟——斑胸草雀来说，这个梦想离现实更近了。

​	这要感谢Timothy Gentner 和他在加利福尼亚大学学生们的杰出工作，他们设计了一个“大脑到鸣叫”的界面，在此界面中，他可以预测一只雀在几秒钟之后的啼叫。

​	“我们直接从神经行为解码现实中各种鸟叫”这是科学家发表在网站 [bioRxiv](https://www.biorxiv.org/content/early/2017/09/27/193987) 的一篇新报告中提到的。阿根廷鸟鸣专家Ezequiel Arneodo 所在的团队称这个系统是一个从神经行为到复杂的神经交流信号的解码器的原型。研究人员说，类似的方法可以推动人类思想到文字转换接口的发展。

​	科学家们说他们可以直接从一只雀的大脑活动预测这只雀的叫声。

​	一只鸣禽的大脑并不大。但它的发声方式与人类的语言相似，这使得这些鸟成为研究记忆和认知的科学家们的最爱。它们的叫声很复杂，就像人类的语言一样，它们也是后天习得的。斑胸草雀从一只年长的鸟那里学会了它的叫声。

​	Makoto Fukushima是美国国立卫生研究院的一名研究员，他使用大脑接口来研究猴子发出的较简单的咕哝声和咕咕声。他说，鸟鸣声的范围更广，这就是为什么新的研究结果“对人类语言的应用具有重要意义”。

​	目前在人类中尝试的大脑界面主要是跟踪反映一个人想要手臂做出特定活动的神经信号，这种神经信号可以用来移动机器人或引导光标非常缓慢地啄出字母。因此，那种可以毫不费力接收到你想要说的内容的头盔或大脑植入装置还远未实现。

​	但正如这项新研究显示的那样，这并非完全不可能。加州大学圣地亚哥分校的研究小组利用醒着的鸟儿身上的硅电极，测量了大脑中被称为感觉运动核的部分神经元的电颤，而这部分神经元正是“形成学习歌曲的指令”产生的地方。

​	这项实验使用了神经网络软件，这是一种机器学习方法。研究人员在程序中输入神经放电的模式和实际产生的叫声，以及它的停止和开始和频率的变化。他们的想法是训练他们的软件去匹配其中一个他们称之为“神经到歌曲的频谱映射”。

​	该团队的主要创新之处在于，通过整合雀科鸣叫的物理模型，简化了从大脑到啼叫的翻译。鸟类不像人类那样有声带。相反，它们把空气喷到喉咙中振动的表面上，这种表面被称为鸣管 。想想看，如果你把两张纸放在一起，在纸的边缘吹气，就能发出尖锐的呜呜声。

​	总结：作者说:“我们直接从神经活动中解码现实中各种各样鸟鸣。在他们的报告中，研究小组称，他们可以在一只鸟发声的30毫秒之前预测它会如何啼叫。

​	你可以在下面的音频中听到结果。记住斑马雀不是夜莺。它的歌更像是断断续续的嘎嘎叫。

​	结果证实是同一种啼叫，正如从雀脑内的神经记录预测的那样。

​	鸣禽已经是一个重要的研究模型。在埃隆·马斯克的神经网络学院(Neuralink)，鸟类科学家是首批聘用的关键人员之一。UCSD专注检测的言语背后肌肉运动技巧也可能是脑机接口技术的一个关键突破点。

​	Facebook表示，它希望人们能够以每分钟100字的速度直接通过大脑打字，随时随地都可以私下发短信。当你需要用唇语表达你的意思时，一个能读懂大脑对肌肉发出的指令的设备可能比一个能读懂“思想”的设备要现实得多。

​	Gentner和他的团队希望他们的雀类能够帮助实现这一目标。他们写道:“我们已经用动物模型演示了一种复杂的通信信号(脑机接口)，”。还补充说，“我们的方法也为生物医学语音假体设备提供了一个有价值的试验场。”

​	换句话说，我们离通过大脑发短信的目标又近了一小步。